/* definitions generated by preprocessor, copy into defines.h */		
#ifndef	PPINC	
#define	_ATMEGA162	// device select: _ATMEGAxxxx
#define	_B1024	// boot size select: _Bxxxx (words), powers of two only
#ifdef	__ICCAVR__	
#include	"iom162.h"	
#endif		
#if	__GNUC__	
#include	<avr/io.h>	
#endif		

/* define pin for enter-self-prog-mode */		
#define	PROGPORT	PORTD
#define	PROGPIN	PIND
#define	PROG_NO	PD4

/* baud rate register value calculation */		
#define	CPU_FREQ	16000000
#define	BAUD_RATE	19200
#define	BRREG_VALUE	51

/* definitions for UART control */		
#define	BAUD_RATE_LOW_REG	UBRR0L
#define	UART_CONTROL_REG	UCSR0B
#define	ENABLE_TRANSMITTER_BIT	TXEN0
#define	ENABLE_RECEIVER_BIT	RXEN0
#define	UART_STATUS_REG	UCSR0A
#define	TRANSMIT_COMPLETE_BIT	TXC0
#define	RECEIVE_COMPLETE_BIT	RXC0
#define	UART_DATA_REG	UDR0

/* definitions for SPM control */		
#define	SPMCR_REG	SPMCR
#define	PAGESIZE	128
#define	APP_END	14336
//#define	LARGE_MEMORY	

/* definitions for device recognition */		
#define	PARTCODE	0x63
#define	SIGNATURE_BYTE_1	0x1E
#define	SIGNATURE_BYTE_2	0x94
#define	SIGNATURE_BYTE_3	0x04

/* indicate that preprocessor result is included */		
#define	PPINC
#endif	



//------------------------------------------------------------------------
// Port Definitions (from hardware.h)
//------------------------------------------------------------------------
//
// PORTA (LEDs)

#define LED_PROG     0     // program   - yellow
#define LED_RAILCOM  1     // railcom   - yellow
#define LED_ACC      2     // accessory - green
#define LED_LOCO     3     // loco      - green
#define LED_GO       4     // sniffing  - blue
#define LED_ON       5     // on        - green
                           // A6 not connected
                           // A7 not connected

//LED prg (orange)
#define                LED_PROG_OFF           PORTA &= ~(1<<LED_PROG)
#define                LED_PROG_ON            PORTA |= (1<<LED_PROG)
#define                LED_PROG_TOGGLE        PORTA ^= (1<<LED_PROG)
//LED railcom (orange)
#define                LED_RAILCOM_OFF        PORTA &= ~(1<<LED_RAILCOM)
#define                LED_RAILCOM_ON         PORTA |= (1<<LED_RAILCOM)
#define                LED_RAILCOM_TOGGLE     PORTA ^= (1<<LED_RAILCOM)
//LED acc (green)
#define                LED_ACC_OFF            PORTA &= ~(1<<LED_ACC)
#define                LED_ACC_ON             PORTA |= (1<<LED_ACC)
#define                LED_ACC_TOGGLE         PORTA ^= (1<<LED_ACC)
//LED loco (green)
#define                LED_LOCO_OFF           PORTA &= ~(1<<LED_LOCO)
#define                LED_LOCO_ON            PORTA |= (1<<LED_LOCO)
#define                LED_LOCO_TOGGLE        PORTA ^= (1<<LED_LOCO)
//LED go (blue)
#define                LED_GO_OFF             PORTA &= ~(1<<LED_GO)
#define                LED_GO_ON              PORTA |= (1<<LED_GO)
#define                LED_GO_TOGGLE          PORTA ^= (1<<LED_GO)
//LED on (green)
#define                LED_ON_OFF             PORTA &= ~(1<<LED_ON)
#define                LED_ON_ON              PORTA |= (1<<LED_ON)
#define                LED_ON_TOGGLE          PORTA ^= (1<<LED_ON)


